////////////////////////////////////////////////////////////////////////////////
// Fichier: GC-Softs/GCS.FaceBook.Exception.pas
// Projet: GCS-FaceBook v0.1 - Copyright (c) 2010 GNU GPL v3
// Auteur: Guillaume Couture <GC-Softs@hotmail.com>
// SiteWeb: http://GcSofts.TuxFamily.org
////////////////////////////////////////////////////////////////////////////////

Unit GCS.FaceBook.Exception;

INTERFACE

Uses
	Classes, SysUtils, uLkJSON;

Type
	////////////////////////////////////////
	// Classe FaceBook Exception
	EGcsFaceBook_Exception = Class(Exception)
	Private
		FResultJSON: TlkJSONobject;
		FError_Code: Integer;
		FError_Msg: String;
	Protected
		Function GetString(): String;
		Function GetType(): String;
	Public
		Constructor Create(AResultJSON: TlkJSONobject);
		Property ResultJSON: TlkJSONobject Read FResultJSON;
		Property Error_Code: Integer Read FError_Code;
		Property Error_Msg: String Read FError_Msg;
	End;

IMPLEMENTATION

////////////////////////////////////////
// Constructor
Constructor EGcsFaceBook_Exception.Create(AResultJSON: TlkJSONobject);
Begin
	FResultJSON := AResultJSON;

	// Rcupration du Code d'Erreur
	If Assigned(FResultJSON.Field['error_code']) Then FError_Code := FResultJSON.Field['error_code'].Value
	Else FError_Code := 0;

	// Rcupration du Message d'Erreur
	If Assigned(FResultJSON.Field['error']) Then FError_Msg := FResultJSON.Field['error'].Field['message'].Value
	Else FError_Msg := FResultJSON.Field['error_msg'].Value;

	Inherited Create(GetString());
End;

////////////////////////////////////////
// Fonction Get Type
Function EGcsFaceBook_Exception.GetType(): String;
Begin
	If Assigned(FResultJSON.Field['error']) And Assigned(FResultJSON.Field['error'].Field['type']) Then
		Result := FResultJSON.Field['error'].Field['type'].Value
	Else Result := 'Exception';
End;

////////////////////////////////////////
// Fonction Get String
Function EGcsFaceBook_Exception.GetString(): String;
Begin
	Result := 'Error Type: ' + GetType() + #13;
	If (FError_Code <> 0) Then Result := Result + 'Error Code: ' + IntToStr(FError_Code) + ': ' + #13;
	Result := Result + 'Error Msg: ' + FError_Msg;
End;

End.
