////////////////////////////////////////////////////////////////////////////////
// Fichier: UFormMain.pas
// Projet: GCS-FaceBook Dmo v0.1 - Copyright (c) 2010 GNU GPL v3
// Auteur: Guillaume Couture <GC-Softs@hotmail.com>
// SiteWeb: http://GcSofts.TuxFamily.org
////////////////////////////////////////////////////////////////////////////////

Unit UFormMain;

INTERFACE

Uses
	Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
	Dialogs, StdCtrls, ToolWin, ActnCtrls, ImgList, ExtCtrls, OleCtrls, SHDocVw,
	ComCtrls,

	ulkJSON,
	GCS.FaceBook.Client,
	GCS.FaceBook.Exception;

Type
	////////////////////////////////////////
	// Classe FormMain
	TFormMain = Class(TForm)
		Memo1: TMemo;
		ImageList1: TImageList;
		CoolBar1: TCoolBar;
		ToolBar1: TToolBar;
		ToolButtonLogin: TToolButton;
		ToolButtonLogout: TToolButton;
		Panel1: TPanel;
		Edit1: TEdit;
		ButtonSend: TButton;
		ToolButtonStatus: TToolButton;
		Procedure FormCreate(Sender: TObject);
		Procedure FormDestroy(Sender: TObject);
		Procedure ButtonSendClick(Sender: TObject);
		Procedure ToolButtonLoginClick(Sender: TObject);
		Procedure ToolButtonLogoutClick(Sender: TObject);
		Procedure Edit1KeyPress(Sender: TObject; var Key: Char);
		Procedure ToolButtonStatusClick(Sender: TObject);
	Public
		Procedure Log(AStr: String);
	End;

Var
	FormMain: TFormMain;
	FB: TGcsFaceBook_Client;

IMPLEMENTATION

{$R *.dfm}

Uses IdGlobal;

////////////////////////////////////////
// Procedure Log
Procedure TFormMain.Log(AStr: String);
Begin
	Memo1.Lines.Add('');
	Memo1.Lines.Add('////////////////////////////////////////');
	Memo1.Lines.Add('// ' + DateTimeToStr(Date + Time));
	Memo1.Lines.Add(AStr);
End;

////////////////////////////////////////
// Procedure Edit KeyPress
Procedure TFormMain.Edit1KeyPress(Sender: TObject; var Key: Char);
Begin
	If (Key = #13) Then Begin
		Key := #0;
		ButtonSendClick(Sender);
	End;
End;

////////////////////////////////////////
// Procedure Form Create
Procedure TFormMain.FormCreate(Sender: TObject);
Begin
	FB := TGcsFaceBook_Client.Create('VOTRE_APPLICATION_ID');
	Memo1.Lines.Add('INDY VERSION: ' + gsIdVersion);
End;

////////////////////////////////////////
// Procedure Form Destroy
Procedure TFormMain.FormDestroy(Sender: TObject);
Begin
	FB.Free;
End;

////////////////////////////////////////
// Procedure FaceBook Login Status
procedure TFormMain.ToolButtonStatusClick(Sender: TObject);
begin
	Log(FB.LoginStatus);
end;

////////////////////////////////////////
// Procedure FaceBook Connect
Procedure TFormMain.ToolButtonLoginClick(Sender: TObject);
Begin
	If FB.Login Then Begin
		ToolButtonLogin.Enabled := False;
		ToolButtonLogout.Enabled := True;
		ToolButtonStatus.Enabled := True;
		Log(
			'Access_Token = ' + FB.Access_Token + #13#10 +
			'Expires_In = ' + FB.Expires_In
		);
	End;
End;

////////////////////////////////////////
// Procedure FaceBook Disconnect
Procedure TFormMain.ToolButtonLogoutClick(Sender: TObject);
Begin
	If FB.Logout Then Begin
		ToolButtonLogin.Enabled := True;
		ToolButtonLogout.Enabled := False;
		ToolButtonStatus.Enabled := False;
	End;
End;

////////////////////////////////////////
// Fonction Button Send Click
Procedure TFormMain.ButtonSendClick(Sender: TObject);
Var ResultJSON: TlkJSONobject;
Begin
	ResultJSON := FB.Graph(Edit1.Text);
	Log(TlkJSON.GenerateText(ResultJSON));
	ResultJSON.Free;
End;

End.

